local ADDON_NAME = ...

BetterPowerBarAltDB = BetterPowerBarAltDB or {}

PlayerPowerBarAlt:SetSize(64, 64)
PlayerPowerBarAlt:SetMovable(true)

local cvar, cvarLabel = "alternateResourceText", "ALTERNATE_RESOURCE_TEXT"

local overlay = CreateFrame("Frame", nil, PlayerPowerBarAlt)
overlay:SetAllPoints()

local texture = overlay:CreateTexture()
texture:SetAllPoints()
texture:SetTexture(1, 1, 1, 0.1)
texture:Hide()
overlay.texture = texture

local locked = true
local moving = nil

overlay:EnableMouse(true)
overlay:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not locked then
		PlayerPowerBarAlt:ClearAllPoints()
		PlayerPowerBarAlt:StartMoving()
		moving = true
	end
end)
overlay:SetScript("OnMouseUp", function(self, button)
	if button == "RightButton" then
		locked = not locked
		if locked then
			self.texture:Hide()
		else
			self.texture:Show()
		end

	elseif moving then
		moving = nil
		PlayerPowerBarAlt:StopMovingOrSizing()
		PlayerPowerBarAlt:SetUserPlaced(false)

		local point, _, _, x, y = PlayerPowerBarAlt:GetPoint(1)
		BetterPowerBarAltDB.point = point
		BetterPowerBarAltDB.x = x
		BetterPowerBarAltDB.y = y

	elseif IsShiftKeyDown() then
		local state = not GetCVarBool(cvar) and 1
		SetCVar(cvar, state, cvarLabel)
	end
end)

--layout cache doesn't like us anymore apparently
overlay:SetScript("OnShow", function(self)
	--print("overlay", "OnShow", BetterPowerBarAltDB.point)
	if BetterPowerBarAltDB.point then
		PlayerPowerBarAlt:ClearAllPoints()
		PlayerPowerBarAlt:SetPoint(BetterPowerBarAltDB.point, UIParent, BetterPowerBarAltDB.point, BetterPowerBarAltDB.x, BetterPowerBarAltDB.y)
	end
end)

overlay:SetScript("OnEnter", function(self) UnitPowerBarAlt_OnEnter(self:GetParent()) end)
overlay:SetScript("OnLeave", function(self) UnitPowerBarAlt_OnLeave(self:GetParent()) end)

--incase the frame is under the ui or offscreen
_G["SLASH_"..ADDON_NAME.."1"] = "/bpba"
_G.SlashCmdList[ADDON_NAME] = function(input)
	if input:trim() == "reset" then
		PlayerPowerBarAlt:ClearAllPoints()
		PlayerPowerBarAlt:SetPoint("CENTER")
		--PlayerPowerBarAlt:SetPoint("BOTTOM", 0, 195)
	end
end
